#ifndef FFABI_INTERNAL_H
#define FFABI_INTERNAL_H

#include <libavutil/samplefmt.h>
#include <libavcodec/avcodec.h>
#include <libavcodec/version.h>

static const enum AVSampleFormat AV_SAMPLE_FMT_S24 = AV_SAMPLE_FMT_NB + 1;

FFM_AudioConvert *ff_ffm_audio_convert_alloc(
                                     enum AVSampleFormat out_fmt,
                                     enum AVSampleFormat in_fmt,
                                     int channels);

void ffabi_ff_mlp_init_crc(void);

void *ffabi_memalign(size_t align, size_t size);
void *ffabi_realloc(void *ptr, size_t size);
void ffabi_free(void *ptr);

#if (LIBAVCODEC_VERSION_MAJOR < 53)
#error "Can't use an ancient ffmpeg or libav"
#endif

#if (LIBAVCODEC_VERSION_MAJOR == 53)

#define AVCodecID CodecID
#define AV_CODEC_ID_NONE CODEC_ID_NONE
#define AV_CODEC_ID_AC3 CODEC_ID_AC3
#define AV_CODEC_ID_DTS CODEC_ID_DTS
#define AV_CODEC_ID_FLAC CODEC_ID_FLAC
#define AV_CODEC_ID_MLP CODEC_ID_MLP
#define AV_CODEC_ID_TRUEHD CODEC_ID_TRUEHD

static inline void avcodec_free_frame(AVFrame **frame)
{
    av_freep(frame);
}

static inline void av_frame_unref(AVFrame *frame)
{
}

#if (LIBAVCODEC_VERSION_MINOR < 40)
void av_log_format_line(void *ptr, int level, const char *fmt, va_list vl,
                        char *line, int line_size, int *print_prefix);
#endif

#endif

#endif /* FFABI_INTERNAL_H */
